<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
      <title>OpenLayers GML Layer Example</title>
	<link rel="stylesheet" href="style.css" type="text/css" />
	<script src='http://dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6.1'></script>
	<script src="../OpenLayers.js"></script>
    	<script type="text/javascript">
    	    var lon = 5;
    	    var lat = 40;
    	    var zoom = 7;
            var path;
            var proj;
            var numclick = 0;
            var click;
    	    var map, layer, markers;
            var markersList=new Array();
            var points=new Array();
            var image;
            OpenLayers.Control.Click = OpenLayers.Class(OpenLayers.Control, {                
                defaultHandlerOptions: {
                    'single': true,
                    'double': false,
                    'pixelTolerance': 0,
                    'stopSingle': false,
                    'stopDouble': false
                },

                initialize: function(options) {
                    this.handlerOptions = OpenLayers.Util.extend(
                        {}, this.defaultHandlerOptions
                    );
                    OpenLayers.Control.prototype.initialize.apply(
                        this, arguments
                    ); 
                    this.handler = new OpenLayers.Handler.Click(
                        this, {
                            'click': this.trigger
                        }, this.handlerOptions
                    );
                }, 

                trigger: function(e) {
                    var lonlat = map.getLonLatFromPixel(e.xy);
                    var size = new OpenLayers.Size(10,17);
            	    var offset = new OpenLayers.Pixel(-(size.w/2), -size.h);
                    var icon = new OpenLayers.Icon('http://boston.openguides.org/markers/AQUA.png',size,offset);
                    markersList[numclick]=new OpenLayers.Marker(new OpenLayers.LonLat(lonlat.lon,lonlat.lat),icon);
                    markers.addMarker(markersList[numclick]);
                    points[numclick]=lonlat;
                    points[numclick].transform(map.getProjectionObject(),proj);
                    numclick++;
		}
            });

    	    function init(){
                 image=document.getElementById("image");
                 //OpenLayers.ProxyHost="/proxy/?url=proxy.unitn.it:3128";
                 proj=new OpenLayers.Projection("EPSG:4326");
		 var options = {
                	projection: new OpenLayers.Projection("EPSG:900913"),
                	displayProjection: new OpenLayers.Projection("EPSG:4326"),
                	units: "m",
                 	numZoomLevels: 18,
                 	maxResolution: 156543.0339,
                	maxExtent: new OpenLayers.Bounds(-20037508, -20037508,
                                                 20037508, 20037508.34)
                 };
    	         map = new OpenLayers.Map('map',options);
    	         layer = new OpenLayers.Layer.VirtualEarth( "VE",{'type': VEMapStyle.Aerial, 'sphericalMercator': true});
    	         map.addLayer(layer);
		 var bounds = new OpenLayers.Bounds(11,46.4,11.2,46.6)
	         map.zoomToExtent(bounds.transform(proj, map.getProjectionObject()));
                 markers = new OpenLayers.Layer.Markers( "Markers" );
            	 map.addLayer(markers);
                 click=new OpenLayers.Control.Click();
                 map.addControl(click);
                 click.activate();
    	    }
            function reset(){
                 numclick = 0;
                 click.activate();
                 for(i=0;i<markersList.length;i++){
                 	markers.removeMarker(markersList[i]);
                 }
                 map.removeLayer(path);
            }
            function compute(){
                 click.deactivate();
                 var queryPoints="";
                 for(i=0;i<points.length-1;i++){
                    queryPoints+=points[i].lon+","+points[i].lat+",";
                 }
                 queryPoints+=points[points.length-1].lon+","+points[points.length-1].lat;
                 try{
                 	path=new OpenLayers.Layer.GML("GML", "cgi-bin/wps.py?service=wps&request=execute&version=1.0.0&identifier=shortestpath&datainputs=[cost=8923;coord="+queryPoints+"]", {projection:proj});
                 	map.addLayer(path);
                        image.innerHTML="<img name=\"image\" src=\"profile.png\">";
                        refreshImage();
                 }catch(e){
                 	alert(e);
                 }                 
            }
            function refreshImage(){
                 try{
                 tmp = new Date();
      		 tmp = "?"+tmp.getTime()
      		 document.images["image"].src = "profile.png"+tmp 
                 setTimeout("refreshImage()", 3000);
                 }catch(e){
                       alert(e);
                 }
            }
    	</script>
  </head>
  <body onload="init()">
      <h1 id="title">GML Layer Example</h1>

      <div id="tags"></div>

      <p id="shortdesc">
          Loads locally stored GML vector data on a basemap. Includes GML example file.
    </p>
    <div id="image"></div>
    <div id="map" class="smallmap"></div>
    <input type="submit" value="Reset!" onclick="reset()">
    <input type="submit" value="Compute!" onclick="compute()">
  </body>
</html>

